Loading...
Searching...
No Matches
sca.h File Reference
`#include "polys/nc/nc.h"`
`#include "misc/intvec.h"`

Go to the source code of this file.

## Functions

ideal | SCAQuotient (const ring r)
static short | scaFirstAltVar (ring r)
static short | scaLastAltVar (ring r)
static void | scaFirstAltVar (ring r, short n)
static void | scaLastAltVar (ring r, short n)
poly | sca_pp_Mult_xi_pp (short i, const poly pPoly, const ring rRing)
bool | p_IsBiHomogeneous (const poly p, const intvec *wx, const intvec *wy, const intvec *wCx, const intvec *wCy, int &dx, int &dy, const ring r)
bool | id_IsBiHomogeneous (const ideal id, const intvec *wx, const intvec *wy, const intvec *wCx, const intvec *wCy, const ring r)
intvec * | ivGetSCAXVarWeights (const ring r)
intvec * | ivGetSCAYVarWeights (const ring r)
static bool | p_IsSCAHomogeneous (const poly p, const intvec *wCx, const intvec *wCy, const ring r)
static bool | id_IsSCAHomogeneous (const ideal id, const intvec *wCx, const intvec *wCy, const ring r)
poly | p_KillSquares (const poly p, const short iFirstAltVar, const short iLastAltVar, const ring r)
ideal | id_KillSquares (const ideal id, const short iFirstAltVar, const short iLastAltVar, const ring r, const bool bSkipZeroes=false)
bool | sca_Force (ring rGR, int b, int e)
void | sca_p_ProcsSet (ring rGR, p_Procs_s *p_Procs)
bool | sca_SetupQuotient (ring rGR, ring rG, bool bCopy)

## Function Documentation

## id_IsBiHomogeneous()

bool id_IsBiHomogeneous | ( | const ideal | id,
|  | const intvec * | wx,
|  | const intvec * | wy,
|  | const intvec * | wCx,
|  | const intvec * | wCy,
|  | const ring | r )

Definition at line 1357 of file sca.cc.

{
if (id == NULL) return true; // zero ideal
const int iSize = IDELEMS(id);
if (iSize == 0) return true;
bool b = true;
int x, y;
for(int i = iSize - 1; (i >= 0 ) && b; i--)
b = p_IsBiHomogeneous(id->m[i], wx, wy, wCx, wCy, x, y, r);
return b;
}
i
int i
Definition cfEzgcd.cc:132
x
Variable x
Definition cfModGcd.cc:4090
b
CanonicalForm b
Definition cfModGcd.cc:4111
y
const CanonicalForm int const CFList const Variable & y
Definition facAbsFact.cc:53
p_IsBiHomogeneous
bool p_IsBiHomogeneous(const poly p, const intvec *wx, const intvec *wy, const intvec *wCx, const intvec *wCy, int &dx, int &dy, const ring r)
Definition sca.cc:1318
NULL
#define NULL
Definition omList.c:12
IDELEMS
#define IDELEMS(i)
Definition simpleideals.h:23

## id_IsSCAHomogeneous()

bool id_IsSCAHomogeneous | ( | const ideal | id,
|  | const intvec * | wCx,
|  | const intvec * | wCy,
|  | const ring | r )

inline static

Definition at line 115 of file sca.h.

{
// inefficient! don't use it in time-critical code!
intvec *wx = ivGetSCAXVarWeights(r);
intvec *wy = ivGetSCAYVarWeights(r);
bool homog = id_IsBiHomogeneous( id, wx, wy, wCx, wCy, r );
delete wx;
delete wy;
return homog;
}
intvec
Definition intvec.h:24
ivGetSCAXVarWeights
intvec * ivGetSCAXVarWeights(const ring r)
Definition sca.cc:1381
ivGetSCAYVarWeights
intvec * ivGetSCAYVarWeights(const ring r)
Definition sca.cc:1409
id_IsBiHomogeneous
bool id_IsBiHomogeneous(const ideal id, const intvec *wx, const intvec *wy, const intvec *wCx, const intvec *wCy, const ring r)
Definition sca.cc:1357

## id_KillSquares()

ideal id_KillSquares | ( | const ideal | id,
|  | const short | iFirstAltVar,
|  | const short | iLastAltVar,
|  | const ring | r,
|  | const bool | bSkipZeroes = false )

Definition at line 1518 of file sca.cc.

{
if (id == NULL) return id; // zero ideal
assume( (iFirstAltVar >= 1) && (iLastAltVar <= rVar(r)) && (iFirstAltVar <= iLastAltVar) );
const int iSize = IDELEMS(id);
if (iSize == 0) return id;
ideal temp = idInit(iSize, id->rank);
#if 0
PrintS("<id_KillSquares>\n");
{
PrintS("ideal id: \n");
for (unsigned int i = 0; i < IDELEMS(id); i++)
{
Print("; id[%d] = ", i+1);
p_Write(id->m[i], r);
}
PrintS(";\n");
PrintLn();
}
#endif
for (int j = 0; j < iSize; j++)
temp->m[j] = p_KillSquares(id->m[j], iFirstAltVar, iLastAltVar, r);
if( bSkipZeroes )
idSkipZeroes(temp);
#if 0
PrintS("<id_KillSquares>\n");
{
PrintS("ideal temp: \n");
for (int i = 0; i < IDELEMS(temp); i++)
{
Print("; temp[%d] = ", i+1);
p_Write(temp->m[i], r);
}
PrintS(";\n");
PrintLn();
}
PrintS("</id_KillSquares>\n");
#endif
// temp->rank = idRankFreeModule(temp, r);
return temp;
}
Print
#define Print
Definition emacs.cc:80
j
int j
Definition facHensel.cc:110
p_KillSquares
poly p_KillSquares(const poly p, const short iFirstAltVar, const short iLastAltVar, const ring r)
Definition sca.cc:1463
assume
#define assume(x)
Definition mod2.h:389
p_Write
void p_Write(poly p, ring lmRing, ring tailRing)
Definition polys0.cc:342
PrintS
void PrintS(const char *s)
Definition reporter.cc:288
PrintLn
void PrintLn()
Definition reporter.cc:314
rVar
static short rVar(const ring r)
define rVar(r) (r->N)
Definition ring.h:598
idInit
ideal idInit(int idsize, int rank)
initialise an ideal / module
Definition simpleideals.cc:35
idSkipZeroes
void idSkipZeroes(ideal ide)
gives an ideal/module the minimal possible size
Definition simpleideals.cc:201

## ivGetSCAXVarWeights()

intvec * ivGetSCAXVarWeights | ( | const ring | r | ) |

Definition at line 1381 of file sca.cc.

{
const unsigned int N = r->N;
const int CommutativeVariable = 0; // bug correction!
const int AntiCommutativeVariable = 0;
intvec* w = new intvec(N, 1, CommutativeVariable);
if(AntiCommutativeVariable != CommutativeVariable)
if( rIsSCA(r) )
{
const unsigned int m_iFirstAltVar = scaFirstAltVar(r);
const unsigned int m_iLastAltVar = scaLastAltVar(r);
for (unsigned int i = m_iFirstAltVar; i<= m_iLastAltVar; i++)
{
(*w)[i-1] = AntiCommutativeVariable;
}
}
return w;
}
N
const CanonicalForm CFMap CFMap & N
Definition cfEzgcd.cc:56
w
const CanonicalForm & w
Definition facAbsFact.cc:51
rIsSCA
static bool rIsSCA(const ring r)
Definition nc.h:190
scaLastAltVar
static short scaLastAltVar(ring r)
Definition sca.h:25
scaFirstAltVar
static short scaFirstAltVar(ring r)
Definition sca.h:18

## ivGetSCAYVarWeights()

intvec * ivGetSCAYVarWeights | ( | const ring | r | ) |

Definition at line 1409 of file sca.cc.

{
const unsigned int N = r->N;
const int CommutativeVariable = 0;
const int AntiCommutativeVariable = 1;
intvec* w = new intvec(N, 1, CommutativeVariable);
if(AntiCommutativeVariable != CommutativeVariable)
if( rIsSCA(r) )
{
const unsigned int m_iFirstAltVar = scaFirstAltVar(r);
const unsigned int m_iLastAltVar = scaLastAltVar(r);
for (unsigned int i = m_iFirstAltVar; i<= m_iLastAltVar; i++)
{
(*w)[i-1] = AntiCommutativeVariable;
}
}
return w;
}

## p_IsBiHomogeneous()

bool p_IsBiHomogeneous | ( | const poly | p,
|  | const intvec * | wx,
|  | const intvec * | wy,
|  | const intvec * | wCx,
|  | const intvec * | wCy,
|  | int & | dx,
|  | int & | dy,
|  | const ring | r )

Definition at line 1318 of file sca.cc.

{
if( p == NULL )
{
dx = 0;
dy = 0;
return true;
}
poly q = p;
int ddx, ddy;
m_GetBiDegree( q, wx, wy, wCx, wCy, ddx, ddy, r); // get bi degree of lm(p)
pIter(q);
for(; q != NULL; pIter(q) )
{
int x, y;
m_GetBiDegree( q, wx, wy, wCx, wCy, x, y, r); // get bi degree of q
if ( (x != ddx) || (y != ddy) ) return false;
}
dx = ddx;
dy = ddy;
return true;
}
p
int p
Definition cfModGcd.cc:4086
m_GetBiDegree
static void m_GetBiDegree(const poly m, const intvec *wx, const intvec *wy, const intvec *wCx, const intvec *wCy, int &dx, int &dy, const ring r)
Definition sca.cc:1273
pIter
#define pIter(p)
Definition monomials.h:37

## p_IsSCAHomogeneous()

bool p_IsSCAHomogeneous | ( | const poly | p,
|  | const intvec * | wCx,
|  | const intvec * | wCy,
|  | const ring | r )

inline static

Definition at line 96 of file sca.h.

{
// inefficient! don't use it in time-critical code!
intvec *wx = ivGetSCAXVarWeights(r);
intvec *wy = ivGetSCAYVarWeights(r);
int x,y;
bool homog = p_IsBiHomogeneous( p, wx, wy, wCx, wCy, x, y, r );
delete wx;
delete wy;
return homog;
}
p_IsBiHomogeneous
bool p_IsBiHomogeneous(const poly p, const intvec *wx, const intvec *wy, const intvec *wCx, const intvec *wCy, int &dx, int &dy, const ring r)
Definition sca.cc:1318

## p_KillSquares()

poly p_KillSquares | ( | const poly | p,
|  | const short | iFirstAltVar,
|  | const short | iLastAltVar,
|  | const ring | r )

Definition at line 1463 of file sca.cc.

{
#ifdef PDEBUG
p_Test(p, r);
assume( (iFirstAltVar >= 1) && (iLastAltVar <= r->N) && (iFirstAltVar <= iLastAltVar) );
#if 0
PrintS("p_KillSquares, p = "); // !
p_Write(p, r);
#endif
#endif
if( p == NULL )
return NULL;
poly pResult = NULL;
poly* ppPrev = &pResult;
for( poly q = p; q!= NULL; pIter(q) )
{
#ifdef PDEBUG
p_Test(q, r);
#endif
// terms will be in the same order because of quasi-ordering!
poly v = m_KillSquares(q, iFirstAltVar, iLastAltVar, r);
if( v != NULL )
{
*ppPrev = v;
ppPrev = &pNext(v);
}
}
#ifdef PDEBUG
p_Test(pResult, r);
#if 0
PrintS("p_KillSquares => "); // !
p_Write(pResult, r);
#endif
#endif
return(pResult);
}
v
const Variable & v
< [in] a sqrfree bivariate poly
Definition facBivar.h:39
m_KillSquares
static poly m_KillSquares(const poly m, const short iFirstAltVar, const short iLastAltVar, const ring r)
Definition sca.cc:1437
pNext
#define pNext(p)
Definition monomials.h:36
p_Test
#define p_Test(p, r)
Definition p_polys.h:161

## sca_Force()

bool sca_Force | ( | ring | rGR,
|  | int | b,
|  | int | e )

Definition at line 1159 of file sca.cc.

{
assume(rGR != NULL);
assume(rIsPluralRing(rGR));
assume(!rIsSCA(rGR));
const int N = rGR->N;
// ring rSaveRing = currRing;
// if(rSaveRing != rGR)
// rChangeCurrRing(rGR);
const ideal idQuotient = rGR->qideal;
ideal tempQ = idQuotient;
if( b <= N && e >= 1 )
tempQ = id_KillSquares(idQuotient, b, e, rGR);
idSkipZeroes( tempQ );
ncRingType( rGR, nc_exterior );
if( idIs0(tempQ) )
rGR->GetNC()->SCAQuotient() = NULL;
else
rGR->GetNC()->SCAQuotient() = tempQ;
scaFirstAltVar( rGR, b );
scaLastAltVar( rGR, e );
nc_p_ProcsSet(rGR, rGR->p_Procs);
// if(rSaveRing != rGR)
// rChangeCurrRing(rSaveRing);
return true;
}
idIs0
BOOLEAN idIs0(ideal h)
returns true if h is the zero ideal
Definition simpleideals.cc:960
nc_p_ProcsSet
void nc_p_ProcsSet(ring rGR, p_Procs_s *p_Procs)
Definition old.gring.cc:3161
nc_exterior
@ nc_exterior
Definition nc.h:21
ncRingType
static nc_type & ncRingType(nc_struct *p)
Definition nc.h:159
id_KillSquares
ideal id_KillSquares(const ideal id, const short iFirstAltVar, const short iLastAltVar, const ring r, const bool bSkipZeroes)
Definition sca.cc:1518
rIsPluralRing
static BOOLEAN rIsPluralRing(const ring r)
we must always have this test!
Definition ring.h:406

## sca_p_ProcsSet()

void sca_p_ProcsSet | ( | ring | rGR,
|  | p_Procs_s * | p_Procs )

Definition at line 1223 of file sca.cc.

{
// "commutative" procedures:
rGR->p_Procs->p_Mult_mm = sca_p_Mult_mm;
rGR->p_Procs->pp_Mult_mm = sca_pp_Mult_mm;
p_Procs->p_Mult_mm = sca_p_Mult_mm;
p_Procs->pp_Mult_mm = sca_pp_Mult_mm;
// non-commutaitve
p_Procs->p_mm_Mult = sca_p_mm_Mult;
p_Procs->pp_mm_Mult = sca_pp_mm_Mult;
// rGR->GetNC()->p_Procs.SPoly = sca_SPoly;
// rGR->GetNC()->p_Procs.ReduceSPoly = sca_ReduceSpoly;
#if 0
// Multiplication procedures:
p_Procs->p_Mult_mm = sca_p_Mult_mm;
_p_procs->p_Mult_mm = sca_p_Mult_mm;
p_Procs->pp_Mult_mm = sca_pp_Mult_mm;
_p_procs->pp_Mult_mm = sca_pp_Mult_mm;
r->GetNC()->mmMultP() = sca_mm_Mult_p;
r->GetNC()->mmMultPP() = sca_mm_Mult_pp;
/*
// ??????????????????????????????????????? coefficients swell...
r->GetNC()->SPoly() = sca_SPoly;
r->GetNC()->ReduceSPoly() = sca_ReduceSpoly;
*/
// r->GetNC()->BucketPolyRed() = gnc_kBucketPolyRed;
// r->GetNC()->BucketPolyRed_Z()= gnc_kBucketPolyRed_Z;
#endif
// local ordering => Mora, otherwise - Buchberger!
if (rHasLocalOrMixedOrdering(rGR))
rGR->GetNC()->p_Procs.GB = cast_A_to_vptr(sca_mora);
else
rGR->GetNC()->p_Procs.GB = cast_A_to_vptr(sca_bba); // sca_gr_bba?
}
cast_A_to_vptr
void * cast_A_to_vptr(A a)
Definition auxiliary.h:386
sca_mora
EXTERN_VAR BBA_Proc sca_mora
Definition gb_hack.h:10
sca_bba
EXTERN_VAR BBA_Proc sca_bba
Definition gb_hack.h:10
sca_p_mm_Mult
static poly sca_p_mm_Mult(poly pPoly, const poly pMonom, const ring rRing)
Definition sca.cc:635
sca_pp_Mult_mm
poly sca_pp_Mult_mm(const poly pPoly, const poly pMonom, const ring rRing, poly &)
sca_p_Mult_mm
poly sca_p_Mult_mm(poly pPoly, const poly pMonom, const ring rRing)
Definition sca.cc:371
sca_pp_mm_Mult
static poly sca_pp_mm_Mult(const poly pPoly, const poly pMonom, const ring rRing)
Definition sca.cc:567
_p_procs
STATIC_VAR p_Procs_s * _p_procs
Definition p_Procs_Set.h:116
rHasLocalOrMixedOrdering
static BOOLEAN rHasLocalOrMixedOrdering(const ring r)
Definition ring.h:769

## sca_pp_Mult_xi_pp()

poly sca_pp_Mult_xi_pp | ( | short | i,
|  | const poly | pPoly,
|  | const ring | rRing )

Definition at line 1201 of file sca.cc.

{
assume(1 <= i);
assume(i <= rVar(rRing));
if(rIsSCA(rRing))
return sca_xi_Mult_pp(i, pPoly, rRing);
poly xi = p_One( rRing);
p_SetExp(xi, i, 1, rRing);
p_Setm(xi, rRing);
poly pResult = pp_Mult_qq(xi, pPoly, rRing);
p_Delete( &xi, rRing);
return pResult;
}
sca_xi_Mult_pp
static poly sca_xi_Mult_pp(short i, const poly pPoly, const ring rRing)
Definition sca.cc:523
p_One
poly p_One(const ring r)
Definition p_polys.cc:1314
p_SetExp
static unsigned long p_SetExp(poly p, const unsigned long e, const unsigned long iBitmask, const int VarOffset)
set a single variable exponent @Note: VarOffset encodes the position in p->exp
Definition p_polys.h:490
p_Setm
static void p_Setm(poly p, const ring r)
Definition p_polys.h:235
p_Delete
static void p_Delete(poly *p, const ring r)
Definition p_polys.h:903
pp_Mult_qq
static poly pp_Mult_qq(poly p, poly q, const ring r)
Definition p_polys.h:1167

## sca_SetupQuotient()

bool sca_SetupQuotient | ( | ring | rGR,
|  | ring | rG,
|  | bool | bCopy )

Definition at line 911 of file sca.cc.

{
//////////////////////////////////////////////////////////////////////////
// checks...
//////////////////////////////////////////////////////////////////////////
if( rG == NULL )
rG = rGR;
assume(rGR != NULL);
assume(rG != NULL);
assume(rIsPluralRing(rG));
#if ((defined(PDEBUG) && OUTPUT) || MYTEST)
PrintS("sca_SetupQuotient(rGR, rG, bCopy)");
{
PrintS("\nrG: \n"); rWrite(rG);
PrintS("\nrGR: \n"); rWrite(rGR);
PrintLn();
}
#endif
if(bCopy)
{
if(rIsSCA(rG) && (rG != rGR))
return sca_Force(rGR, scaFirstAltVar(rG), scaLastAltVar(rG));
else
return false;
}
assume(!bCopy);
const int N = rG->N;
// if( (ncRingType(rG) != nc_skew) || (ncRingType(rG) != nc_comm) )
// return false;
#if OUTPUT
PrintS("sca_SetupQuotient: qring?\n");
#endif
if(rGR->qideal == NULL) // there should be a factor!
return false;
#if OUTPUT
PrintS("sca_SetupQuotient: qideal!!!\n");
#endif
// if((rG->qideal != NULL) && (rG != rGR) ) // we cannot change from factor to factor at the time, sorry!
// return false;
int iAltVarEnd = -1;
int iAltVarStart = N+1;
const nc_struct* NC = rG->GetNC();
const ring rBase = rG; //NC->basering;
const matrix C = NC->C; // live in rBase!
const matrix D = NC->D; // live in rBase!
#if OUTPUT
PrintS("sca_SetupQuotient: AltVars?!\n");
#endif
for(int i = 1; i < N; i++)
{
for(int j = i + 1; j <= N; j++)
{
if( MATELEM(D,i,j) != NULL) // !!!???
{
#if ((defined(PDEBUG) && OUTPUT) || MYTEST)
Print("Nonzero D[%d, %d]\n", i, j);
#endif
return false;
}
assume(MATELEM(C,i,j) != NULL); // after CallPlural!
number c = p_GetCoeff(MATELEM(C,i,j), rBase);
if( n_IsMOne(c, rBase->cf) ) // !!!???
{
if( i < iAltVarStart)
iAltVarStart = i;
if( j > iAltVarEnd)
iAltVarEnd = j;
} else
{
if( !n_IsOne(c, rBase->cf) )
{
#if ((defined(PDEBUG) && OUTPUT) || MYTEST)
Print("Wrong Coeff at: [%d, %d]\n", i, j);
#endif
return false;
}
}
}
}
#if ((defined(PDEBUG) && OUTPUT) || MYTEST)
Print("AltVars?1: [%d, %d]\n", iAltVarStart, iAltVarEnd);
#endif
if((iAltVarEnd == -1) || (iAltVarStart == (N+1)))
{
if (N>1) return false; // no alternating variables
iAltVarEnd=iAltVarStart=1;
}
for(int i = 1; i < N; i++)
{
for(int j = i + 1; j <= N; j++)
{
assume(MATELEM(C,i,j) != NULL); // after CallPlural!
number c = p_GetCoeff(MATELEM(C,i,j), rBase);
if( (iAltVarStart <= i) && (j <= iAltVarEnd) ) // S <= i < j <= E
{ // anticommutative part
if( !n_IsMOne(c, rBase->cf) )
{
#if ((defined(PDEBUG) && OUTPUT) || MYTEST)
Print("Wrong Coeff at: [%d, %d]\n", i, j);
#endif
return false;
}
}
else
{ // should commute
if( !n_IsOne(c, rBase->cf) )
{
#if ((defined(PDEBUG) && OUTPUT) || MYTEST)
Print("Wrong Coeff at: [%d, %d]\n", i, j);
#endif
return false;
}
}
}
}
#if ((defined(PDEBUG) && OUTPUT) || MYTEST)
Print("AltVars!?: [%d, %d]\n", iAltVarStart, iAltVarEnd);
#endif
assume( 1 <= iAltVarStart );
assume( iAltVarStart <= iAltVarEnd );
assume( iAltVarEnd <= N );
// ring rSaveRing = assureCurrentRing(rG);
assume(rGR->qideal != NULL);
assume(rGR->N == rG->N);
// assume(rG->qideal == NULL); // ?
const ideal idQuotient = rGR->qideal;
#if ((defined(PDEBUG) && OUTPUT) || MYTEST)
PrintS("Analyzing quotient ideal:\n");
idPrint(idQuotient); // in rG!!!
#endif
// check for
// y_{iAltVarStart}^2, y_{iAltVarStart+1}^2, \ldots, y_{iAltVarEnd}^2 (iAltVarEnd > iAltVarStart)
// to be within quotient ideal.
int b = N+1;
int e = -1;
if(rIsSCA(rG))
{
b = si_min(b, scaFirstAltVar(rG));
e = si_max(e, scaLastAltVar(rG));
#if ((defined(PDEBUG) && OUTPUT) || MYTEST)
Print("AltVars!?: [%d, %d]\n", b, e);
#endif
}
for ( int i = iAltVarStart; (i <= iAltVarEnd); i++ )
if( (i < b) || (i > e) ) // otherwise it's ok since rG is an SCA!
{
poly square = p_One( rG);
p_SetExp(square, i, 2, rG); // square = var(i)^2.
p_Setm(square, rG);
// square = NF( var(i)^2 | Q )
// NOTE: there is no better way to check this in general!
square = nc_NF(idQuotient, NULL, square, 0, 1, rG); // must ran in currRing == rG!
if( square != NULL ) // var(i)^2 is not in Q?
{
p_Delete(&square, rG);
return false;
}
}
#if ((defined(PDEBUG) && OUTPUT) || MYTEST)
Print("ScaVars!: [%d, %d]\n", iAltVarStart, iAltVarEnd);
#endif
//////////////////////////////////////////////////////////////////////////
// ok... here we go. let's setup it!!!
//////////////////////////////////////////////////////////////////////////
ideal tempQ = id_KillSquares(idQuotient, iAltVarStart, iAltVarEnd, rG); // in rG!!!
#if ((defined(PDEBUG) && OUTPUT) || MYTEST)
PrintS("Quotient: \n");
iiWriteMatrix((matrix)idQuotient,"__",1, rG, 0);
PrintS("tempSCAQuotient: \n");
iiWriteMatrix((matrix)tempQ,"__",1, rG, 0);
#endif
idSkipZeroes( tempQ );
ncRingType( rGR, nc_exterior );
scaFirstAltVar( rGR, iAltVarStart );
scaLastAltVar( rGR, iAltVarEnd );
if( idIs0(tempQ) )
rGR->GetNC()->SCAQuotient() = NULL;
else
rGR->GetNC()->SCAQuotient() = idrMoveR(tempQ, rG, rGR); // deletes tempQ!
nc_p_ProcsSet(rGR, rGR->p_Procs); // !!!!!!!!!!!!!!!!!
#if ((defined(PDEBUG) && OUTPUT) || MYTEST)
PrintS("SCAQuotient: \n");
if(tempQ != NULL)
iiWriteMatrix((matrix)tempQ,"__",1, rGR, 0);
else
PrintS("(NULL)\n");
#endif
return true;
}
si_max
static int si_max(const int a, const int b)
Definition auxiliary.h:125
si_min
static int si_min(const int a, const int b)
Definition auxiliary.h:126
n_IsMOne
static FORCE_INLINE BOOLEAN n_IsMOne(number n, const coeffs r)
TRUE iff 'n' represents the additive inverse of the one element, i.e. -1.
Definition coeffs.h:478
n_IsOne
static FORCE_INLINE BOOLEAN n_IsOne(number n, const coeffs r)
TRUE iff 'n' represents the one element.
Definition coeffs.h:474
nc_NF
EXTERN_VAR NF_Proc nc_NF
Definition gb_hack.h:9
D
#define D(A)
Definition gentable.cc:128
idPrint
#define idPrint(id)
Definition ideals.h:46
sca_Force
bool sca_Force(ring rGR, int b, int e)
Definition sca.cc:1159
iiWriteMatrix
void iiWriteMatrix(matrix im, const char *n, int dim, const ring r, int spaces)
set spaces to zero by default
Definition matpol.cc:828
MATELEM
#define MATELEM(mat, i, j)
1-based access to matrix
Definition matpol.h:29
matrix
ip_smatrix * matrix
Definition matpol.h:43
p_GetCoeff
#define p_GetCoeff(p, r)
Definition monomials.h:50
idrMoveR
ideal idrMoveR(ideal &id, ring src_r, ring dest_r)
Definition prCopy.cc:248
rWrite
void rWrite(ring r, BOOLEAN details)
Definition ring.cc:227
nc_struct
Definition nc.h:68
nc_struct::C
matrix C
Definition nc.h:75
nc_struct::D
matrix D
Definition nc.h:76

## scaFirstAltVar() [1/2]

short scaFirstAltVar | ( | ring | r | ) |

inline static

Definition at line 18 of file sca.h.

{
assume(rIsSCA(r));
return (r->GetNC()->FirstAltVar());
}

## scaFirstAltVar() [2/2]

void scaFirstAltVar | ( | ring | r,
|  | short | n )

inline static

Definition at line 34 of file sca.h.

{
assume(rIsSCA(r));
r->GetNC()->FirstAltVar() = n;
}

## scaLastAltVar() [1/2]

short scaLastAltVar | ( | ring | r | ) |

inline static

Definition at line 25 of file sca.h.

{
assume(rIsSCA(r));
return (r->GetNC()->LastAltVar());
}

## scaLastAltVar() [2/2]

void scaLastAltVar | ( | ring | r,
|  | short | n )

inline static

Definition at line 41 of file sca.h.

{
assume(rIsSCA(r));
r->GetNC()->LastAltVar() = n;
}

## SCAQuotient()

ideal SCAQuotient | ( | const ring | r | ) |

inline

Definition at line 10 of file sca.h.

{
assume(rIsSCA(r));
return r->GetNC()->SCAQuotient();
}